diff --git a/src/main/java/net/minecraft/client/entity/player/EntityPlayerSP.java b/src/main/java/net/minecraft/client/entity/player/EntityPlayerSP.java
index a250cf302..307acfc02 100644
--- a/src/main/java/net/minecraft/client/entity/player/EntityPlayerSP.java
+++ b/src/main/java/net/minecraft/client/entity/player/EntityPlayerSP.java
@@ -373,6 +373,7 @@ public class EntityPlayerSP extends EntityPlayer
                         return;
                     }
                 }
+                sender.sendMessage(TextFormatting.RED + "Command '" + args[0] + "' does not exist!");
             }catch (Exception e) {
                 e.printStackTrace();
                 mc.ingameGUI.addChatMessage(TextFormatting.RED + "Error!");
diff --git a/src/main/java/net/minecraft/client/gui/GuiGameOver.java b/src/main/java/net/minecraft/client/gui/GuiGameOver.java
index 8fa5614eb..8593ee79c 100644
--- a/src/main/java/net/minecraft/client/gui/GuiGameOver.java
+++ b/src/main/java/net/minecraft/client/gui/GuiGameOver.java
@@ -1,6 +1,8 @@
 package net.minecraft.client.gui;
 
+import net.minecraft.client.entity.player.EntityClientPlayerMP;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.packet.Packet0KeepAlive;
 import net.minecraft.core.player.gamemode.Gamemode;
 import org.lwjgl.opengl.GL11;
 
@@ -11,10 +13,19 @@ import net.minecraft.core.net.command.TextFormatting;
 
 public class GuiGameOver extends GuiScreen
 {
+    protected int tickCount = 0;
 
     public GuiGameOver()
     {
     }
+    @Override
+    public void tick(){
+        tickCount++;
+        if (mc.isMultiplayerWorld() && mc.thePlayer instanceof EntityClientPlayerMP && tickCount % 10 == 0){
+            EntityClientPlayerMP clientPlayerMP = (EntityClientPlayerMP) mc.thePlayer;
+            clientPlayerMP.sendQueue.addToSendQueue(new Packet0KeepAlive());
+        }
+    }
 
     @Override
 	public void init()
diff --git a/src/main/java/net/minecraft/client/gui/hud/HotbarComponent.java b/src/main/java/net/minecraft/client/gui/hud/HotbarComponent.java
index 439ff60d4..80e3509f4 100644
--- a/src/main/java/net/minecraft/client/gui/hud/HotbarComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/HotbarComponent.java
@@ -69,7 +69,7 @@ public class HotbarComponent
 
         // Setup items
         GL11.glEnable(GL11.GL_DEPTH_TEST);
-        GL11.glDisable(GL11.GL_BLEND);
+        GL11.glEnable(GL11.GL_BLEND);
         GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         Lighting.enableInventoryLight();
         int lastHotbarStart = (mc.thePlayer.inventory.hotbarOffset + 27) % 36;
@@ -146,7 +146,7 @@ public class HotbarComponent
 
         // Setup items
         GL11.glEnable(GL11.GL_DEPTH_TEST);
-        GL11.glDisable(GL11.GL_BLEND);
+        GL11.glEnable(GL11.GL_BLEND);
         GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         Lighting.enableInventoryLight();
 
diff --git a/src/main/java/net/minecraft/client/render/FontRenderer.java b/src/main/java/net/minecraft/client/render/FontRenderer.java
index 8c6b9ff58..bf44707f7 100644
--- a/src/main/java/net/minecraft/client/render/FontRenderer.java
+++ b/src/main/java/net/minecraft/client/render/FontRenderer.java
@@ -3,6 +3,7 @@ package net.minecraft.client.render;
 import net.minecraft.client.lang.text.Text;
 import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.helper.ChatAllowedCharacters;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.client.util.helper.Colors;
@@ -361,90 +362,139 @@ public class FontRenderer {
             int fontIndex;
             int var6;
             if (c == '\247' && i + 1 < text.length()) {
-                fontIndex = "0123456789abcdefklmnor".indexOf(text.toLowerCase().charAt(i + 1));
-                if (fontIndex < 16) {
-                    this.obfuscatedStyle = false;
-                    this.boldStyle = false;
-                    this.strikethroughStyle = false;
-                    this.underlineStyle = false;
-                    this.italicStyle = false;
-                    if (fontIndex < 0) {
-                        fontIndex = 15;
+                char colorSymbol = text.toLowerCase().charAt(i + 1);
+                if (colorSymbol == '<'){ // Full rgb color code
+                    int offAmount = 1;
+                    int j = i + 2;
+                    StringBuilder colorValue = new StringBuilder();
+                    boolean ended = false;
+                    while (j < text.length()){
+                        offAmount++;
+                        if (text.charAt(j) == '>'){
+                            ended = true;
+                            break;
+                        }
+                        colorValue.append(text.charAt(j));
+                        j++;
                     }
 
-                    if (flag) {
-                        fontIndex += 16;
-                    }
+                    if (ended){
+                        i += offAmount;
 
-                    var6 = this.colorCode[fontIndex];
-                    this.textColor = var6;
-                    GL11.glColor4f((float)(var6 >> 16) / 255.0F, (float)(var6 >> 8 & 255) / 255.0F, (float)(var6 & 255) / 255.0F, this.alpha);
-                } else if (fontIndex == 16) {
-                    this.obfuscatedStyle = true;
-                } else if (fontIndex == 17) {
-                    this.boldStyle = true;
-                } else if (fontIndex == 18) {
-                    this.strikethroughStyle = true;
-                } else if (fontIndex == 19) {
-                    this.underlineStyle = true;
-                } else if (fontIndex == 20) {
-                    this.italicStyle = true;
-                } else if (fontIndex == 21) {
-                    this.obfuscatedStyle = false;
-                    this.boldStyle = false;
-                    this.strikethroughStyle = false;
-                    this.underlineStyle = false;
-                    this.italicStyle = false;
-                    GL11.glColor4f(this.red, this.blue, this.green, this.alpha);
-                }
+                        int colorInt = 0xFFFFFF;
+                        try {
+                            colorInt = Integer.decode("0x" + colorValue.toString().toLowerCase());
+                        } catch (NumberFormatException ignored){
+                        }
 
-                ++i;
-            } else {
-                fontIndex = ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c);
-                if (this.obfuscatedStyle && fontIndex > 0) {
-                    do {
-                        var6 = this.random.nextInt(ChatAllowedCharacters.ALLOWED_CHARACTERS.length());
-                    } while (this.charWidth[fontIndex + 32] != this.charWidth[var6 + 32]);
+                        float r = (float)(colorInt >> 16) / 255.0F;
+                        float g = (float)(colorInt >> 8 & 0xff) / 255.0F;
+                        float b = (float)(colorInt & 0xff) / 255.0F;
 
-                    fontIndex = var6;
-                }
+                        this.obfuscatedStyle = false;
+                        this.boldStyle = false;
+                        this.strikethroughStyle = false;
+                        this.underlineStyle = false;
+                        this.italicStyle = false;
 
-                float var9 = this.renderCharAtPos(fontIndex, c, this.italicStyle);
-                if (this.boldStyle) {
-                    ++this.posX;
-                    this.renderCharAtPos(fontIndex, c, this.italicStyle);
-                    --this.posX;
-                    ++var9;
-                }
+                        if (flag){
+                            r /= 4;
+                            g /= 4;
+                            b /= 4;
+                        }
 
-                Tessellator var7;
-                if(this.strikethroughStyle) {
-                    var7 = Tessellator.instance;
-                    GL11.glDisable(GL11.GL_TEXTURE_2D);
-                    var7.startDrawingQuads();
-                    var7.addVertex(this.posX, this.posY + (float)(this.fontHeight / 2), 0.0D);
-                    var7.addVertex(this.posX + var9, this.posY + (float)(this.fontHeight / 2), 0.0D);
-                    var7.addVertex(this.posX + var9, this.posY + (float)(this.fontHeight / 2) - 1.0F, 0.0D);
-                    var7.addVertex(this.posX, this.posY + (float)(this.fontHeight / 2) - 1.0F, 0.0D);
-                    var7.draw();
-                    GL11.glEnable(GL11.GL_TEXTURE_2D);
-                }
+                        this.textColor = colorInt;
+                        GL11.glColor4f(r, g, b, this.alpha);
+                        continue;
+                    }
+                } else {
+                    fontIndex = "0123456789abcdefklmnor".indexOf(colorSymbol);
+                    if (fontIndex != -1){
+                        if (fontIndex < 16) {
+                            this.obfuscatedStyle = false;
+                            this.boldStyle = false;
+                            this.strikethroughStyle = false;
+                            this.underlineStyle = false;
+                            this.italicStyle = false;
+                            if (fontIndex < 0) {
+                                fontIndex = 15;
+                            }
 
-                if(this.underlineStyle) {
-                    var7 = Tessellator.instance;
-                    GL11.glDisable(GL11.GL_TEXTURE_2D);
-                    var7.startDrawingQuads();
-                    int var8 = this.underlineStyle ? -1 : 0;
-                    var7.addVertex(this.posX + (float)var8, this.posY + (float)this.fontHeight, 0.0D);
-                    var7.addVertex(this.posX + var9, this.posY + (float)this.fontHeight, 0.0D);
-                    var7.addVertex(this.posX + var9, this.posY + (float)this.fontHeight - 1.0F, 0.0D);
-                    var7.addVertex(this.posX + (float)var8, this.posY + (float)this.fontHeight - 1.0F, 0.0D);
-                    var7.draw();
-                    GL11.glEnable(GL11.GL_TEXTURE_2D);
+                            if (flag) {
+                                fontIndex += 16;
+                            }
+
+                            var6 = this.colorCode[fontIndex];
+                            this.textColor = var6;
+                            GL11.glColor4f((float)(var6 >> 16) / 255.0F, (float)(var6 >> 8 & 255) / 255.0F, (float)(var6 & 255) / 255.0F, this.alpha);
+                        } else if (fontIndex == 16) {
+                            this.obfuscatedStyle = true;
+                        } else if (fontIndex == 17) {
+                            this.boldStyle = true;
+                        } else if (fontIndex == 18) {
+                            this.strikethroughStyle = true;
+                        } else if (fontIndex == 19) {
+                            this.underlineStyle = true;
+                        } else if (fontIndex == 20) {
+                            this.italicStyle = true;
+                        } else if (fontIndex == 21) {
+                            this.obfuscatedStyle = false;
+                            this.boldStyle = false;
+                            this.strikethroughStyle = false;
+                            this.underlineStyle = false;
+                            this.italicStyle = false;
+                            GL11.glColor4f(this.red, this.blue, this.green, this.alpha);
+                        }
+                        i++;
+                        continue;
+                    }
                 }
+            }
+            c = text.charAt(i);
+            fontIndex = ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c);
+            if (this.obfuscatedStyle && fontIndex > 0) {
+                do {
+                    var6 = this.random.nextInt(ChatAllowedCharacters.ALLOWED_CHARACTERS.length());
+                } while (this.charWidth[fontIndex + 32] != this.charWidth[var6 + 32]);
+
+                fontIndex = var6;
+            }
 
-                this.posX += (float)((int)var9);
+            float var9 = this.renderCharAtPos(fontIndex, c, this.italicStyle);
+            if (this.boldStyle) {
+                ++this.posX;
+                this.renderCharAtPos(fontIndex, c, this.italicStyle);
+                --this.posX;
+                ++var9;
             }
+
+            Tessellator var7;
+            if(this.strikethroughStyle) {
+                var7 = Tessellator.instance;
+                GL11.glDisable(GL11.GL_TEXTURE_2D);
+                var7.startDrawingQuads();
+                var7.addVertex(this.posX, this.posY + (float)(this.fontHeight / 2), 0.0D);
+                var7.addVertex(this.posX + var9, this.posY + (float)(this.fontHeight / 2), 0.0D);
+                var7.addVertex(this.posX + var9, this.posY + (float)(this.fontHeight / 2) - 1.0F, 0.0D);
+                var7.addVertex(this.posX, this.posY + (float)(this.fontHeight / 2) - 1.0F, 0.0D);
+                var7.draw();
+                GL11.glEnable(GL11.GL_TEXTURE_2D);
+            }
+
+            if(this.underlineStyle) {
+                var7 = Tessellator.instance;
+                GL11.glDisable(GL11.GL_TEXTURE_2D);
+                var7.startDrawingQuads();
+                int var8 = this.underlineStyle ? -1 : 0;
+                var7.addVertex(this.posX + (float)var8, this.posY + (float)this.fontHeight, 0.0D);
+                var7.addVertex(this.posX + var9, this.posY + (float)this.fontHeight, 0.0D);
+                var7.addVertex(this.posX + var9, this.posY + (float)this.fontHeight - 1.0F, 0.0D);
+                var7.addVertex(this.posX + (float)var8, this.posY + (float)this.fontHeight - 1.0F, 0.0D);
+                var7.draw();
+                GL11.glEnable(GL11.GL_TEXTURE_2D);
+            }
+
+            this.posX += (float)((int)var9);
         }
 
     }
@@ -499,6 +549,7 @@ public class FontRenderer {
         if(string == null) {
             return 0;
         } else {
+            string = TextFormatting.removeAllFormatting(string);
             int stringWidth = 0;
             boolean addSpacerPixel = false;
 
@@ -530,9 +581,9 @@ public class FontRenderer {
     }
 
     public int getCharWidth(char c) {
-        if (c == '§') {
+        /*if (c == '§') {
             return -1;
-        } else if (c == ' ') {
+        } else */if (c == ' ') {
             return 4;
         } else {
             int fontIndex = ChatAllowedCharacters.ALLOWED_CHARACTERS.indexOf(c);
diff --git a/src/main/java/net/minecraft/client/render/ItemRenderer.java b/src/main/java/net/minecraft/client/render/ItemRenderer.java
index 17af8e541..3ee5a3986 100644
--- a/src/main/java/net/minecraft/client/render/ItemRenderer.java
+++ b/src/main/java/net/minecraft/client/render/ItemRenderer.java
@@ -242,30 +242,30 @@ public class ItemRenderer
     private void renderFireInFirstPerson(float f)
     {
         Tessellator tessellator = Tessellator.instance;
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 0.9F);
+        GL11.glColor4f(1.0F, 1.0F, 1.0F, 0.85F);
         GL11.glEnable(GL_BLEND);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
-        float f1 = 1.0F;
+        float scale = 1.5f;
         for(int i = 0; i < 2; i++)
         {
             GL11.glPushMatrix();
             IconCoordinate texture = TextureRegistry.getTexture("minecraft:block/fire");
-            float f2 = (float) texture.getIconUMin();
-            float f3 = (float) texture.getIconUMax();
-            float f4 = (float) texture.getIconVMin();
-            float f5 = (float) texture.getIconVMax();
-            float f6 = (0.0F - f1) / 2.0F;
-            float f7 = f6 + f1;
-            float f8 = 0.0F - f1 / 2.0F;
-            float f9 = f8 + f1;
+            float uMin = (float) texture.getIconUMin();
+            float uMax = (float) texture.getIconUMax();
+            float vMin = (float) texture.getIconVMin();
+            float vMax = (float) texture.getIconVMax();
+            float xMin = (0.0F - scale) / 2.0F;
+            float xMax = xMin + scale;
+            float yMin = 0.0F - scale / 2.0F;
+            float yMax = yMin + scale;
             float f10 = -0.5F;
-            GL11.glTranslatef((float)(-(i * 2 - 1)) * 0.24F, -0.3F, 0.0F);
+            GL11.glTranslatef((float)(-(i * 2 - 1)) * 0.4F, -0.3F, 0.0F);
             GL11.glRotatef((float)(i * 2 - 1) * 10F, 0.0F, 1.0F, 0.0F);
             tessellator.startDrawingQuads();
-            tessellator.addVertexWithUV(f6, f8, f10, f3, f5);
-            tessellator.addVertexWithUV(f7, f8, f10, f2, f5);
-            tessellator.addVertexWithUV(f7, f9, f10, f2, f4);
-            tessellator.addVertexWithUV(f6, f9, f10, f3, f4);
+            tessellator.addVertexWithUV(xMin, yMin - 0.5, f10, uMax, vMax);
+            tessellator.addVertexWithUV(xMax, yMin - 0.5, f10, uMin, vMax);
+            tessellator.addVertexWithUV(xMax, yMax, f10, uMin, vMin);
+            tessellator.addVertexWithUV(xMin, yMax, f10, uMax, vMin);
             tessellator.draw();
             GL11.glPopMatrix();
         }
diff --git a/src/main/java/net/minecraft/client/render/RenderBlockCache.java b/src/main/java/net/minecraft/client/render/RenderBlockCache.java
index 123c7d1fb..2f5b87f33 100644
--- a/src/main/java/net/minecraft/client/render/RenderBlockCache.java
+++ b/src/main/java/net/minecraft/client/render/RenderBlockCache.java
@@ -46,7 +46,7 @@ final public class RenderBlockCache {
 
 		if(LightmapHelper.isLightmapEnabled() || mc.fullbright) {
 			int lightEmission = Block.lightEmission[block.id];
-			if(lightEmission > 0) {
+			if(lightEmission >= 15) {
 				return 1.0f;
 			}
 			if(!mc.isAmbientOcclusionEnabled()) {
@@ -89,7 +89,8 @@ final public class RenderBlockCache {
     public int getLightmapCoord(int relX, int relY, int relZ) {
     	int index = (relX + CACHE_RANGE) * CACHE_SIZE * CACHE_SIZE + (relY + CACHE_RANGE) * CACHE_SIZE + (relZ + CACHE_RANGE);
     	if(!lightmapCoordCached[index]) {
-    		lightmapCoordValue[index] = access.getLightmapCoord(relX + offsetX, relY + offsetY, relZ + offsetZ, Block.lightEmission[block.id]);
+    		int lightEmission = Block.lightEmission[block.id];
+    		lightmapCoordValue[index] = access.getLightmapCoord(relX + offsetX, relY + offsetY, relZ + offsetZ, lightEmission >= 15 ? 15 : 0);
     		lightmapCoordCached[index] = true;
     	}
     	return lightmapCoordValue[index];
diff --git a/src/main/java/net/minecraft/client/render/RenderBlocks.java b/src/main/java/net/minecraft/client/render/RenderBlocks.java
index b43167368..515d52b1e 100644
--- a/src/main/java/net/minecraft/client/render/RenderBlocks.java
+++ b/src/main/java/net/minecraft/client/render/RenderBlocks.java
@@ -8,6 +8,7 @@ import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 
@@ -275,8 +276,18 @@ public class RenderBlocks
         
     	if(LightmapHelper.isLightmapEnabled()) {
     		if(overbright) {
-				// TODO use correct skylight value, requires a getSavedLightValue method in WorldSource
-    			int lmc = LightmapHelper.getOverbrightLightmapCoord(0);
+    			int dirX2 = dirX;
+    			int dirY2 = dirY;
+    			int dirZ2 = dirZ;
+    			
+    			if(depth > FULL_CUBE_THRESHOLD) {
+    				dirX2 = 0;
+    				dirY2 = 0;
+    				dirZ2 = 0;
+    			}
+    			
+    			int lmc = LightmapHelper.getOverbrightLightmapCoord(blockAccess.getSavedLightValue(LightLayer.Sky, x + dirX2, y + dirY2, z + dirZ2));
+    			
         		lightmapCoordTopLeft = lightmapCoordBottomLeft = lightmapCoordBottomRight = lightmapCoordTopRight = lmc;
     		}else {
         		if(ao) {
diff --git a/src/main/java/net/minecraft/client/render/RenderEngine.java b/src/main/java/net/minecraft/client/render/RenderEngine.java
index 91c1467a0..39100aefb 100644
--- a/src/main/java/net/minecraft/client/render/RenderEngine.java
+++ b/src/main/java/net/minecraft/client/render/RenderEngine.java
@@ -83,62 +83,67 @@ public class RenderEngine {
 
 		dynamicTextures.clear();
 
-		TexturePack tp = texturePacks.getHighestPriorityPack();
+		TexturePack tp;
 
 		if(mc.gameSettings.animations.value != 0) {
 			boolean useCustomAnimations = mc.gameSettings.animations.value == 2;
 
 			try {
-				if(useCustomAnimations && tp.hasFile("/anim/custom_water_still.png")) {
-					dynamicTextures.add(new DynamicTextureCustom(mc, "/anim/custom_water_still.png", TextureRegistry.getTexture("minecraft:block/water_still")));
+				tp = mc.texturePackList.getHighestPriorityTexturePackWithFile("/anim/custom_water_still.png");
+				if(useCustomAnimations && tp != null) {
+					dynamicTextures.add(new DynamicTextureCustom(mc, tp, "/anim/custom_water_still.png", "minecraft:block/water_still", false));
 				}else {
 					dynamicTextures.add(new DynamicTextureWaterStill());
 				}
 
-				if(useCustomAnimations && tp.hasFile("/anim/custom_water_flowing.png")) {
-					dynamicTextures.add(new DynamicTextureCustom(mc, "/anim/custom_water_flowing.png", TextureRegistry.getTexture("minecraft:block/water_flowing")));
+				tp = mc.texturePackList.getHighestPriorityTexturePackWithFile("/anim/custom_water_flowing.png");
+				if(useCustomAnimations && tp != null) {
+					dynamicTextures.add(new DynamicTextureCustom(mc, tp, "/anim/custom_water_flowing.png", "minecraft:block/water_flowing", true));
 				}else {
 					dynamicTextures.add(new DynamicTextureWaterFlow());
 				}
 
-				if(useCustomAnimations && tp.hasFile("/anim/custom_lava_still.png")) {
-					dynamicTextures.add(new DynamicTextureCustom(mc, "/anim/custom_lava_still.png", TextureRegistry.getTexture("minecraft:block/lava_still")));
+				tp = mc.texturePackList.getHighestPriorityTexturePackWithFile("/anim/custom_lava_still.png");
+				if(useCustomAnimations && tp != null) {
+					dynamicTextures.add(new DynamicTextureCustom(mc, tp, "/anim/custom_lava_still.png", "minecraft:block/lava_still", false));
 				}else {
 					dynamicTextures.add(new DynamicTextureLavaStill());
 				}
 
-				if(useCustomAnimations && tp.hasFile("/anim/custom_lava_flowing.png")) {
-					dynamicTextures.add(new DynamicTextureCustom(mc, "/anim/custom_lava_flowing.png", TextureRegistry.getTexture("minecraft:block/lava_flowing")));
+				tp = mc.texturePackList.getHighestPriorityTexturePackWithFile("/anim/custom_lava_flowing.png");
+				if(useCustomAnimations && tp != null) {
+					dynamicTextures.add(new DynamicTextureCustom(mc, tp, "/anim/custom_lava_flowing.png", "minecraft:block/lava_flowing", true));
 				}else {
 					dynamicTextures.add(new DynamicTextureLavaFlowing());
 				}
 
-				if(useCustomAnimations && tp.hasFile("/anim/custom_portal.png")) {
-					dynamicTextures.add(new DynamicTextureCustom(mc, "/anim/custom_portal.png", TextureRegistry.getTexture("minecraft:block/portal_nether")));
+				tp = mc.texturePackList.getHighestPriorityTexturePackWithFile("/anim/custom_portal.png");
+				if(useCustomAnimations && tp != null) {
+					dynamicTextures.add(new DynamicTextureCustom(mc, tp, "/anim/custom_portal.png", "minecraft:block/portal_nether", false));
 				}else {
 					dynamicTextures.add(new DynamicTexturePortal(false));
 				}
 
-				if(useCustomAnimations && tp.hasFile("/anim/custom_fire.png")) {
-					dynamicTextures.add(new DynamicTextureCustom(mc, "/anim/custom_fire.png", TextureRegistry.getTexture("minecraft:block/fire")));
+				tp = mc.texturePackList.getHighestPriorityTexturePackWithFile("/anim/custom_fire.png");
+				if(useCustomAnimations && tp != null) {
+					dynamicTextures.add(new DynamicTextureCustom(mc, tp, "/anim/custom_fire.png", "minecraft:block/fire", false));
 				}else {
 					dynamicTextures.add(new DynamicTextureFire());
 				}
 
 				String[] fireflycolors = new String[] {"blue", "orange", "green", "red"};
-				IconCoordinate[] fireflytiles = new IconCoordinate[] {
-						TextureRegistry.getTexture("minecraft:block/lantern_firefly_blue"),
-						TextureRegistry.getTexture("minecraft:block/lantern_firefly_orange"),
-						TextureRegistry.getTexture("minecraft:block/lantern_firefly_green"),
-						TextureRegistry.getTexture("minecraft:block/lantern_firefly_red")};
 				for(int i=0; i < 4; i++) {
 					String color = fireflycolors[i];
-					IconCoordinate icon = fireflytiles[i];
-
-					if(useCustomAnimations && tp.hasFile("/anim/custom_firefly_jar_" + color + ".png")) {
-						dynamicTextures.add(new DynamicTextureCustom(mc, "/anim/custom_firefly_jar_" + color + ".png", icon));
+					
+					String animationPath = "/anim/custom_firefly_jar_" + color + ".png";
+					String texturePath = "/assets/minecraft/textures/block/lantern_firefly_" + color + ".png";
+					String textureName = "minecraft:block/lantern_firefly_" + color;
+					
+					tp = mc.texturePackList.getHighestPriorityTexturePackWithFile(animationPath);
+					if(useCustomAnimations && tp != null) {
+						dynamicTextures.add(new DynamicTextureCustom(mc, tp, animationPath, textureName, false));
 					}else {
-						dynamicTextures.add(new DynamicTextureFireflyJar(mc, icon));
+						dynamicTextures.add(new DynamicTextureFireflyJar(mc, texturePath, textureName));
 					}
 				}
 
@@ -146,13 +151,13 @@ public class RenderEngine {
 				errors.add(e);
 			}
 
-			if(useCustomAnimations && tp.hasFile("/anim/animations.json")) {
+			tp = mc.texturePackList.getHighestPriorityTexturePackWithFile("/anim/animations.json");
+			if(useCustomAnimations && tp != null) {
 				loadCustomAnimations(tp, errors);
 			}
 
 			dynamicTextures.add(new DynamicTextureTrommel(mc, TextureRegistry.getTexture("minecraft:block/trommel_active_front"), true));
 			dynamicTextures.add(new DynamicTextureTrommel(mc, TextureRegistry.getTexture("minecraft:block/trommel_active_back"), false));
-
 		}else {
 			updateDynamicTexture(new DynamicTextureTrommel(mc, TextureRegistry.getTexture("minecraft:block/trommel_active_front"), true));
 			updateDynamicTexture(new DynamicTextureTrommel(mc, TextureRegistry.getTexture("minecraft:block/trommel_active_back"), false));
@@ -163,14 +168,14 @@ public class RenderEngine {
 		dynamicTextures.add(new DynamicTextureCompass(mc));
 	}
 	
-	private void loadCustomAnimations(TexturePack selectedTexturePack, List<Throwable> errors) {
+	private void loadCustomAnimations(TexturePack tp, List<Throwable> errors) {
 		if(!mc.gameSettings.customAnimations.value) {
 			return;
 		}
 		try {
 			List<DynamicTexture> customAnimations = new ArrayList<>();
 
-			JsonObject rootObject = TexturePackJsonHelper.readJsonObject(selectedTexturePack, "/anim/animations.json");
+			JsonObject rootObject = TexturePackJsonHelper.readJsonObject(tp, "/anim/animations.json");
 			JsonArray animations = TexturePackJsonHelper.getArray(rootObject, "animations");
 			try {
 				for(int i=0; i < animations.length(); i++) {
@@ -184,16 +189,13 @@ public class RenderEngine {
 
                         String id = TexturePackJsonHelper.getString(animationObject, "id");
 						String name = TexturePackJsonHelper.getString(animationObject, "name");
-
-						if (!TextureRegistry.hasTexture(id)) throw new TexturePackException("Texture id '" + id + "' appears to be invalid!");
-						IconCoordinate texture = TextureRegistry.getTexture(id);
-
-						String texturePath = "/anim/" + name + ".png";
-						if(!selectedTexturePack.hasFile(texturePath)) {
-							throw new TexturePackException("File '"+texturePath+"' does not exist!");
+						
+						String animationSource = "/anim/" + name + ".png";
+						if(!tp.hasFile(animationSource)) {
+							throw new TexturePackException("File '"+animationSource+"' does not exist!");
 						}
-
-						customAnimations.add(new DynamicTextureCustom(mc, texturePath, texture));
+						
+						customAnimations.add(new DynamicTextureCustom(mc, tp, animationSource, id, false));
 					}catch (TexturePackException e) {
 						throw new TexturePackException("Error at index " + i, e);
 					}
@@ -467,19 +469,19 @@ public class RenderEngine {
 		return tex;
 	}
 	
-	public void updateDynamicTexture(DynamicTexture texture) {
-		texture.update();
+	public void updateDynamicTexture(DynamicTexture anim) {
+		anim.update();
 		
-		Buffer.checkBufferSize(texture.imageData.length);
+		Buffer.checkBufferSize(anim.imageData.length);
 		Buffer.reset();
-		buffer.put(texture.imageData);
-		buffer.position(0).limit(texture.imageData.length);
+		buffer.put(anim.imageData);
+		buffer.position(0).limit(anim.imageData.length);
 
-		texture.getTexture().bindTexture();
-		IconCoordinate icon = texture.texture;
+		anim.texture.parentAtlas.bindTexture();
+		IconCoordinate icon = anim.texture;
 
-		int x1 = texture.texture.iconX;
-		int y1 = texture.texture.iconY;
+		int x1 = icon.iconX;
+		int y1 = icon.iconY;
 		glTexSubImage2D(GL_TEXTURE_2D, 0, x1, y1, icon.width, icon.height, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
 		
 		if(mc.gameSettings.mipmapLevels.value > 0) {
@@ -494,17 +496,17 @@ public class RenderEngine {
 						int i = (y * lod) * icon.width + (x * lod);
 						int j = y * (icon.width/lod) + x;
 
-						Buffer.buffer.put(j * 4 + 0, texture.imageData[i * 4 + 0]);
-						Buffer.buffer.put(j * 4 + 1, texture.imageData[i * 4 + 1]);
-						Buffer.buffer.put(j * 4 + 2, texture.imageData[i * 4 + 2]);
-						Buffer.buffer.put(j * 4 + 3, texture.imageData[i * 4 + 3]);
+						Buffer.buffer.put(j * 4 + 0, anim.imageData[i * 4 + 0]);
+						Buffer.buffer.put(j * 4 + 1, anim.imageData[i * 4 + 1]);
+						Buffer.buffer.put(j * 4 + 2, anim.imageData[i * 4 + 2]);
+						Buffer.buffer.put(j * 4 + 3, anim.imageData[i * 4 + 3]);
 					}
 				}
 
 				Buffer.buffer.position(0).limit(icon.width/lod * icon.height/lod * 4);
 
-				x1 = texture.texture.iconX;
-				y1 = texture.texture.iconY;
+				x1 = icon.iconX;
+				y1 = icon.iconY;
 				glTexSubImage2D(GL_TEXTURE_2D, level, x1/lod, y1/lod, icon.width/lod, icon.height/lod, GL_RGBA, GL_UNSIGNED_BYTE, buffer);
 			}
 		}
@@ -558,27 +560,6 @@ public class RenderEngine {
 		}
 	}
 	
-	private int weightedAverageColor(int i, int j) {
-		int k = (i & 0xff000000) >> 24 & 0xff;
-		int l = (j & 0xff000000) >> 24 & 0xff;
-		char c = '\377';
-		if (k + l == 0) {
-			k = 1;
-			l = 1;
-			c = '\0';
-		}
-		int i1 = (i >> 16 & 0xff) * k;
-		int j1 = (i >> 8 & 0xff) * k;
-		int k1 = (i & 0xff) * k;
-		int l1 = (j >> 16 & 0xff) * l;
-		int i2 = (j >> 8 & 0xff) * l;
-		int j2 = (j & 0xff) * l;
-		int k2 = (i1 + l1) / (k + l);
-		int l2 = (j1 + i2) / (k + l);
-		int i3 = (k1 + j2) / (k + l);
-		return c << 24 | k2 << 16 | l2 << 8 | i3;
-	}
-	
 	public BufferedImage getImage(String name) {
 		try {
 			BufferedImage img;
@@ -681,9 +662,17 @@ public class RenderEngine {
 	 * @param errors A list of errors to be displayed in a popup when selecting the texture pack. Errors of type {@link TexturePackException} will be displayed as a readable message
 	 */
 	public void refreshTextures(List<Throwable> errors) {
+		// Animations may change the size of textures, so they need to be initialized before the atlas is generated
+		initDynamicTextures(errors);
+		
 		for (AtlasStitcher stitcher : TextureRegistry.stitcherMap.values()){
 			stitcher.generateAtlas();
 		}
+
+		for(int i=0; i < dynamicTextures.size(); i++) {
+			dynamicTextures.get(i).postInit();
+		}
+		
 		textureNameToImageMap.forEach((i, img) -> setupTexture(img, i));
 		textureMap.forEach((name, id) -> setupTexture(name));
 		
@@ -708,7 +697,6 @@ public class RenderEngine {
 				ioexception1.printStackTrace();
 			}
 		}
-		initDynamicTextures(errors);
 
 		Colors.loadColors();
 		
